# Machine Learning Kernels

[**MLKernels.jl**](https://github.com/trthatcher/MLKernels.jl) is a Julia package for Mercer 
kernel functions (or the covariance functions of Gaussian processes) that are used in the 
kernel methods of machine learning. This package provides a collection of kernel datatypes 
for representing kernel functions as well as an efficient set of methods to compute or 
approximate kernel matrices. 

## Installation

The package may be added by running one of the following code:

```
(v0.7) pkg> add MLKernels
```

## Getting Started

Documentation on the interface implemented by [**MLKernels.jl**](https://github.com/trthatcher/MLKernels.jl) is available under the 
interface section listed in the table of contents below or on the sidebar:

  - [**Interface**](interface.md) - the MLKernels API
  - [**Kernels**](kernels.md) - a listing of the implemented kernel functions and their properties
  - [**Kernel Theory**](kernel-theory.md) - documentation on the theory surrounding kernel functions and the kernel trick
